/**
 * 
 */
package net.ildnpedia;


import java.util.logging.Level;
import java.util.logging.Logger;


//import net.ildnpedia.utility.LogLevel;


/**
 * 
 * Questa è una classe di appoggio per Converter . 
 * 
 * @author <a mailto="marco.ferretti@fermasoft.com">Marco Ferretti </a>
 * @version $Revision: 1.7 $
 */
public class DIVWikifier {
	static final String STARTTOKEN = "<div class=";
	static final String ENDTOKEN = "</div>";

	private StringBuffer value = new StringBuffer();

	/**
	 * Questa classe valuta la stringa in input alla ricerca di <div> e li trasforma in 
	 * wiki style stuff
	 * @param string
	 */
	public DIVWikifier ( StringBuffer string , Logger logger) throws Exception{
		int openTokens = countTokens(string,STARTTOKEN);
		int closeTokens = countTokens(string,ENDTOKEN);
		int da = -1;
		int a = -1;
		StringBuffer buffer = new StringBuffer (  );
		
		logger.entering(DIVWikifier.class.getName(),"parsing divs ");
		
		if ( openTokens != closeTokens ){
			String message = "Guida malformattata ! Il numero di div aperti è " + openTokens +
					" mentre quello di <div> chiusi è " + closeTokens +"\n" ;
			logger.log(Level.SEVERE,message);
			logger.exiting(DIVWikifier.class.getName(),"parsing divs ");
			Convert.setError();
			throw new RuntimeException ( message );
		}
		
		while ( string.indexOf(STARTTOKEN) > -1 ) { // ci sono ancora div da tradurre ??
			buffer.delete(0,buffer.length()); // buffer di appoggio. lo pulisco
			da = string.lastIndexOf(STARTTOKEN);// apertura div + a destra
			a = string.indexOf(ENDTOKEN,da); // la sua chiusura
//			logger.log(LogLevel.INFO,"evaluating : " + string.substring(da,a+ENDTOKEN.length() )); // debug
			buffer.append(string.substring(0,da)); // quello che c'è prima del div lo salvo
			buffer.append(translate(string.substring(da,a+ENDTOKEN.length() )).toString()); // traduco il div ( come porzione di testo tra <div class ... > e </div>
			buffer.append(string.substring(a+ENDTOKEN.length())); //e ci appendo quello che c'è dopo
			string.delete(0,string.length()); // cancello quello che c'era prima
			string.append(buffer.toString()); // e ricomincio
		}
		
		value = string;
		logger.exiting(DIVWikifier.class.getName(),"parsing divs ");
		
	}
	
	/**
	 * Traduce il tag div di xoops con il corrispondente template ( se esiste ) di ildnpedia
	 * @param value
	 * @return
	 */
	StringBuffer translate ( String value ) {
		int start = value.indexOf(STARTTOKEN);
		int end   = value.indexOf("\"", start+STARTTOKEN.length());
		start = end ;
		end = value.indexOf("\"", start+1);
//		String name = value.substring(start+1,end);
		String name = null;
		
		/*
		 * 18-04-2004
		 * Marco Feretti
		 * 
		 * Cerchiamo di essere tolleranti con le guide : se la classe del div non è chiusa 
		 * cerchiamo di chiuderla noi ....
		 */
		if ( end != -1 ) {
			name = value.substring(start+1,end);
		} else  {
			end = value.indexOf(">", start+1);
			name = value.substring(start+1,end) ;
			end = end -1 ; // posizioniamoci indietro di un carattere per far sì che tutto continui normalmente....
		}
		StringBuffer buffer = new StringBuffer ( );
		start = value.indexOf(">",end) + 1;
		end = value.indexOf(ENDTOKEN,start);
		/*
		 * Modifica per uso box Terminale
		 */
//		if ( name.equalsIgnoreCase("terminale") || name.equalsIgnoreCase("terminal") || name.equalsIgnoreCase("riquadro")){
//			buffer.append("<pre>");
//			buffer.append(value.substring(start,end));
//			buffer.append("</pre>");
		if ( name.equalsIgnoreCase("riquadro")){
			buffer.append("<pre>");
			buffer.append(value.substring(start,end));
			buffer.append("</pre>");
		} else if ( name.equalsIgnoreCase("titolo") ) {
			buffer.append("<h1><font color=\"#0066FF\">");
			buffer.append(value.substring(start,end));
			buffer.append("</font></h1>");
		} else {
			buffer.append("{{" );
			buffer.append(getWikiBoxName(name));
			buffer.append("|");
			buffer.append(escape(value.substring(start,end)));
			buffer.append("}}");
		}
		return buffer;
	}
	
	/**
	 * Fà l'escape della stringa che deve andare all'interno di 
	 * un box 
	 * @param string
	 * @return
	 */
	String escape ( String string ) {
		String escapeBegins = "<nowiki>";
		String escapeEnds = "</nowiki>";
		String[] searchFor = {"=","#"};
		String ret = null;
		StringBuffer buffer = new StringBuffer( string );
		String check = null;
		StringBuffer temp = null;
		int index = 0;
		for ( int i = 0; i< searchFor.length; ++i ) {
			while ( (index = buffer.indexOf(searchFor[i],index)) > -1 ) {
				// cerco le occorrenze ...
				temp = new StringBuffer(buffer.substring(0,index)); // salvo tutto quello che c'è prima
				if ( index + escapeEnds.length() < buffer.length() ){
					check = buffer.substring(index,index+escapeEnds.length());
					if ( check.indexOf(escapeEnds) == -1 ){
						// devo fare l'escape
						temp.append(escapeBegins);
						temp.append(buffer.charAt(index));
						temp.append(escapeEnds);
					}
				} else {
					// sicuramente devo fare l'escape 
					temp.append(escapeBegins);
					temp.append(buffer.charAt(index));
					temp.append(escapeEnds);
				}
				temp.append(buffer.substring(index+1)); // e salvo quello che c'è dopo
				buffer.delete(0,buffer.length()); // e ricomincio
				buffer.append(temp.toString());
				index = index + escapeEnds.length(); // portando avanti l'indice
			}
		}
		ret = buffer.toString();
		return ret;
	}
	
	/**
	 * Metodo di utilità . Serve per contare i tokens.
	 * @param buffer
	 * @param token
	 * @return
	 */
	int countTokens ( StringBuffer buffer , String token ){
		
		// 	Stranamente StringTokenizer.countTokens() dava risultati sballati .... quindi me lo sono fatto da me
		int num = 0;
		int last = 0;
		
		while ( (last = buffer.indexOf(token,last)) > -1 ){
			last += token.length();
			++num;
		}
		return num;
	}
	
	/**
	 * Metodo di utilità. I nomi dei templates di ildnpedia non sono uguali a 
	 * quelli di xoops ... e le maiuscole ( a differenza di html ) contano !
	 * @param name
	 * @return
	 */
	String getWikiBoxName (String name){
		String ret = null;
		if ( name.equalsIgnoreCase("Attenzione") )
			ret = "Attenzione";
		else if ( name.equalsIgnoreCase("Nota") )
			ret = "Nota";
		else if ( name.equalsIgnoreCase("Tip") )
			ret = "Tips";
		/*
		 * modifica per box Terminale
		 */
		else if ( name.equalsIgnoreCase("terminale") || name.equalsIgnoreCase("terminal") ) 
			ret = "Terminale";
		return ret;
	}

	/**
	 * Nested method
	 * @return
	 */
	public StringBuffer evaluate () {
		return value;
	}

}
